/* Generated by wayland-scanner 1.18.0 */

#ifndef SHARE_BUFFER_CLIENT_PROTOCOL_H
#define SHARE_BUFFER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_share_buffer The share_buffer protocol
 * @section page_ifaces_share_buffer Interfaces
 * - @subpage page_iface_qt_share_buffer - 
 * @section page_copyright_share_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the plugins of the Qt Toolkit.
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_server_buffer;
struct qt_share_buffer;

/**
 * @page page_iface_qt_share_buffer qt_share_buffer
 * @section page_iface_qt_share_buffer_api API
 * See @ref iface_qt_share_buffer.
 */
/**
 * @defgroup iface_qt_share_buffer The qt_share_buffer interface
 */
extern const struct wl_interface qt_share_buffer_interface;

/**
 * @ingroup iface_qt_share_buffer
 * @struct qt_share_buffer_listener
 */
struct qt_share_buffer_listener {
	/**
	 */
	void (*cross_buffer)(void *data,
			     struct qt_share_buffer *qt_share_buffer,
			     struct qt_server_buffer *buffer);
};

/**
 * @ingroup iface_qt_share_buffer
 */
static inline int
qt_share_buffer_add_listener(struct qt_share_buffer *qt_share_buffer,
			     const struct qt_share_buffer_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_share_buffer,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_qt_share_buffer
 */
#define QT_SHARE_BUFFER_CROSS_BUFFER_SINCE_VERSION 1


/** @ingroup iface_qt_share_buffer */
static inline void
qt_share_buffer_set_user_data(struct qt_share_buffer *qt_share_buffer, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_share_buffer, user_data);
}

/** @ingroup iface_qt_share_buffer */
static inline void *
qt_share_buffer_get_user_data(struct qt_share_buffer *qt_share_buffer)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_share_buffer);
}

static inline uint32_t
qt_share_buffer_get_version(struct qt_share_buffer *qt_share_buffer)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_share_buffer);
}

/** @ingroup iface_qt_share_buffer */
static inline void
qt_share_buffer_destroy(struct qt_share_buffer *qt_share_buffer)
{
	wl_proxy_destroy((struct wl_proxy *) qt_share_buffer);
}

#ifdef  __cplusplus
}
#endif

#endif
